Index: main/plugin-forms/src/org/ametys/plugins/forms/OrphanFormsGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/OrphanFormsGenerator.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/OrphanFormsGenerator.java	(working copy)
@@ -18,6 +18,9 @@
 import java.io.IOException;
 import java.util.List;
 
+import javax.jcr.ItemNotFoundException;
+import javax.jcr.Node;
+
 import org.apache.avalon.framework.service.ServiceException;
 import org.apache.avalon.framework.service.ServiceManager;
 import org.apache.cocoon.ProcessingException;
@@ -35,10 +38,10 @@
 public class OrphanFormsGenerator extends ServiceableGenerator
 {
     /** Component gathering methods to query forms in JCR */
-    FormPropertiesManager _formPropertiesManager;
+    private FormPropertiesManager _formPropertiesManager;
     
     /** Component gathering methods to manipulate SQL forms */
-    FormTableManager _formTableManager;
+    private FormTableManager _formTableManager;
     
     @Override
     public void service(ServiceManager serviceManager) throws ServiceException
@@ -63,6 +66,35 @@
                 form = _formPropertiesManager.getForm(formId);
                 if (form == null)
                 {
+                    Node frozenContentNode = _formPropertiesManager.getMostRecentFormFrozenContent(formId);
+                    if (frozenContentNode != null)
+                    {
+                        String contentUUId = frozenContentNode.getProperty("jcr:frozenUuid").getString();
+                        String title = frozenContentNode.getProperty("ametys:title").getString();
+                        String contributor = frozenContentNode.getProperty("ametys:contributor").getString();
+                        
+                        attrs.addCDATAAttribute("contentTitle", title);
+                        if (frozenContentNode.hasProperty("ametys:site"))
+                        {
+                            attrs.addCDATAAttribute("siteName", frozenContentNode.getProperty("ametys:site").getString());
+                        }
+                        
+                        attrs.addCDATAAttribute("lastContributor", contributor);
+                        
+                        boolean stillExists = true;
+                        try
+                        {
+                            frozenContentNode.getSession().getNodeByIdentifier(contentUUId);
+                        }
+                        catch (ItemNotFoundException e)
+                        {
+                            stillExists = false;
+                        }
+                        
+                        attrs.addCDATAAttribute("stillExists", Boolean.toString(stillExists));
+                    }
+                
+                    // Table attrs
                     attrs.addCDATAAttribute("name", tableName);
                     attrs.addCDATAAttribute("total", Integer.toString(_formTableManager.getTotalSubmissions(formId)));
                     
Index: main/plugin-forms/src/org/ametys/plugins/forms/data/ContentFormsGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/data/ContentFormsGenerator.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/data/ContentFormsGenerator.java	(working copy)
@@ -90,6 +90,7 @@
                         // replace '/' character with ' ', otherwise the url wont get a match in cocoon 
                         atts.addCDATAAttribute("encodedLabel", new URI(null, null,  URIDecoder.decode(form.getLabel()).replace('/', ' '), null).getRawPath());
                         
+                        atts.addCDATAAttribute("workflowName", form.getWorkflowName());
                         XMLUtils.createElement(contentHandler, "form", atts);
                     }
                     
Index: main/plugin-forms/src/org/ametys/plugins/forms/data/FormEntriesGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/data/FormEntriesGenerator.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/data/FormEntriesGenerator.java	(working copy)
@@ -38,7 +38,12 @@
 import org.ametys.plugins.forms.FormsException;
 import org.ametys.plugins.forms.jcr.FormPropertiesManager;
 import org.ametys.plugins.forms.table.FormTableManager;
+import org.ametys.plugins.forms.workflow.FormEntriesWorkflow;
 import org.ametys.plugins.repository.AmetysObjectResolver;
+import org.ametys.runtime.util.I18nUtils;
+import org.ametys.runtime.util.I18nizableText;
+
+import com.opensymphony.workflow.spi.Step;
 
 /**
  * Searches the list of forms contained in a given set of contents.
@@ -60,12 +65,20 @@
     /** The ametys object resolver. */
     protected AmetysObjectResolver _resolver;
     
+    /** The workflow component for form entries. */
+    protected FormEntriesWorkflow _formEntriesWorkflow;
+    
+    /** Component gathering utility methods to manipulate internationalizable text */
+    protected I18nUtils _i18nUtils;
+    
     @Override
     public void service(ServiceManager serviceManager) throws ServiceException
     {
         super.service(serviceManager);
         _resolver = (AmetysObjectResolver) serviceManager.lookup(AmetysObjectResolver.ROLE);
         _formPropertiesManager = (FormPropertiesManager) serviceManager.lookup(FormPropertiesManager.ROLE);
+        _formEntriesWorkflow = (FormEntriesWorkflow) serviceManager.lookup(FormEntriesWorkflow.ROLE);
+        _i18nUtils = (I18nUtils) serviceManager.lookup(I18nUtils.ROLE);
         _formTableManager = new FormTableManager();
     }
     
@@ -92,7 +105,7 @@
             }
             
             Map<String, FieldValue> columns = _formTableManager.getColumns(form);
-            List<UserEntry> entries = _formTableManager.getSubmissions(form, columns, start, limit);
+            List<UserEntry> entries = _formTableManager.getSubmissions(form, columns, start, limit, null);
             int totalSubmissions = _formTableManager.getTotalSubmissions(form.getId());
             
             contentHandler.startDocument();
@@ -151,6 +164,17 @@
         atts.addCDATAAttribute("id", Integer.toString(entry.getId()));
         atts.addCDATAAttribute("submission-date", _DATE_FORMAT.format(entry.getCreationDate()));
         
+        // Workflow step
+        Integer workflowId = entry.getWorkflowId();
+        if (workflowId != null)
+        {
+            String workflowName = _formEntriesWorkflow.getWorkflowName(workflowId);
+            Step step = (Step) _formEntriesWorkflow.getCurrentSteps(workflowId).iterator().next();
+            
+            String stepName = _formEntriesWorkflow.getStepName(workflowName, step.getStepId());
+            atts.addCDATAAttribute("workflowStep", _i18nUtils.translate(new I18nizableText("application", stepName)));
+        }
+        
         XMLUtils.startElement(contentHandler, "entry", atts);
         
         for (FieldValue fdValue : entry.getValues())
@@ -182,7 +206,7 @@
             
             XMLUtils.createElement(contentHandler, "field", atts, displayValue);
         }
-        
+
         XMLUtils.endElement(contentHandler, "entry");
     }
     
Index: main/plugin-forms/src/org/ametys/plugins/forms/data/FormsListGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/data/FormsListGenerator.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/data/FormsListGenerator.java	(working copy)
@@ -52,14 +52,14 @@
     
     /** The form data manager */
     private FormTableManager _formTableManager;
-
+    
     /** The Ametys object resolver */
     protected AmetysObjectResolver _resolver;
     
     @Override
     public void service(ServiceManager serviceManager) throws ServiceException
     {
-        _formPropertiesManager = (FormPropertiesManager) serviceManager.lookup(FormPropertiesManager.ROLE); 
+        _formPropertiesManager = (FormPropertiesManager) serviceManager.lookup(FormPropertiesManager.ROLE);
         _formTableManager = new FormTableManager();
         _resolver = (AmetysObjectResolver) serviceManager.lookup(AmetysObjectResolver.ROLE);
     }
@@ -94,11 +94,12 @@
                     try
                     {
                         Map<String, FieldValue> columns = _formTableManager.getColumns(form);
-                        List<UserEntry> entries = _formTableManager.getSubmissions(form, columns, 0, Integer.MAX_VALUE);
+                        List<UserEntry> entries = _formTableManager.getSubmissions(form, columns, 0, Integer.MAX_VALUE, null);
                         int totalSubmissions = _formTableManager.getTotalSubmissions(form.getId());
                         Date lastSubmissionDate = _getLastSubmissionDate(entries);
                         attrs.addCDATAAttribute("id", form.getId());
                         attrs.addCDATAAttribute("encodedLabel", new URI(null, null,  URIDecoder.decode(form.getLabel()).replace('/', ' '), null).getRawPath());
+                        attrs.addCDATAAttribute("workflowName", form.getWorkflowName());
                         
                         XMLUtils.startElement(contentHandler, "form", attrs);
                         
Index: main/plugin-forms/src/org/ametys/plugins/forms/data/UserEntry.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/data/UserEntry.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/data/UserEntry.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -32,17 +32,22 @@
     /** The entry values. */
     protected List<FieldValue> _values;
     
+    /** The workflow id of the entry */
+    protected Integer _workflowId;
+    
     /**
      * Constructor with parameters.
-     * @param id
-     * @param creationDate
-     * @param values
+     * @param id the id of the user enrty
+     * @param creationDate the date at which this entry was submitted
+     * @param values the form values
+     * @param workflowId the id of the corresponding workflow instance
      */
-    public UserEntry(int id, Date creationDate, List<FieldValue> values)
+    public UserEntry(int id, Date creationDate, List<FieldValue> values, Integer workflowId)
     {
         this._id = id;
         this._creationDate = creationDate;
         this._values = values;
+        this._workflowId = workflowId;
     }
 
     /**
@@ -99,4 +104,21 @@
         this._values = values;
     }
     
+    /**
+     * Set the workflow id of this entry
+     * @param workflowId the id of the workflow of this entry
+     */
+    public void setWorkflowId(Integer workflowId)
+    {
+        this._workflowId = workflowId;
+    }
+    
+    /**
+     * Get the workflow id of this user entry
+     * @return the workflow id of this entry
+     */
+    public Integer getWorkflowId()
+    {
+        return _workflowId;
+    }
 }
Index: main/plugin-forms/src/org/ametys/plugins/forms/jcr/FormPropertiesManager.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/jcr/FormPropertiesManager.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/jcr/FormPropertiesManager.java	(working copy)
@@ -64,9 +64,6 @@
     /** The avalon component ROLE. */
     public static final String ROLE = FormPropertiesManager.class.getName();
     
-    /** JCR relative path to root node. */
-    public static final String ROOT_REPO = AmetysObjectResolver.ROOT_REPO;
-    
     /** Plugins root node name. */
     public static final String PLUGINS_NODE = "ametys-internal:plugins";
     
@@ -85,6 +82,9 @@
     /** "Label" property name. */
     public static final String FORM_PROPERTY_LABEL = RepositoryConstants.NAMESPACE_PREFIX + ":label";
     
+    /** "last modified" property name. */
+    public static final String CONTENT_LAST_MODIFIED_PROPERTY_LABEL = RepositoryConstants.NAMESPACE_PREFIX + ":lastModified";
+    
     /** "Receipt field ID" property name. */
     public static final String FORM_PROPERTY_RECEIPT_FIELD_ID = RepositoryConstants.NAMESPACE_PREFIX + ":receipt-field-id";
     
@@ -103,6 +103,9 @@
     /** "Emails" property name. */
     public static final String FORM_PROPERTY_EMAILS = RepositoryConstants.NAMESPACE_PREFIX + ":notification-emails";
     
+    /** "Workflow name" property name. */
+    public static final String FORM_PROPERTY_WORKFLOW_NAME = RepositoryConstants.NAMESPACE_PREFIX + ":workflow-name";
+    
     /** "ID" field property name. */
     public static final String FIELD_PROPERTY_ID = RepositoryConstants.NAMESPACE_PREFIX + ":id";
     
@@ -124,14 +127,18 @@
     /** The Site manager. */
     protected SiteManager _siteManager;
     
+    /** The resolver for ametys objects */
+    protected AmetysObjectResolver _resolver;
+
     /** The plugin name. */
     protected String _pluginName;
-
+    
     @Override
     public void service(ServiceManager serviceManager) throws ServiceException
     {
         _repository = (Repository) serviceManager.lookup(AbstractRepository.ROLE);
         _siteManager = (SiteManager) serviceManager.lookup(SiteManager.ROLE);
+        _resolver = (AmetysObjectResolver) serviceManager.lookup(AmetysObjectResolver.ROLE);
     }
     
     @Override
@@ -202,8 +209,47 @@
     }
     
     /**
+     * Get the most recent frozen content that contain the form of the given id 
+     * @param formId the id of the form
+     * @return the list of frozen content nodes containing the form
+     * @throws FormsException if an error occurs while retrieving the forms' frozen content nodes
+     */
+    public Node getMostRecentFormFrozenContent(String formId) throws FormsException
+    {
+        Session session = null;
+        try
+        {
+            session = _repository.login();
+            
+            String xpathQuery = "//element(" + formId + ", nt:frozenNode)/../.. order by @" + CONTENT_LAST_MODIFIED_PROPERTY_LABEL + " descending";
+            
+            QueryManager queryManager = session.getWorkspace().getQueryManager();
+            Query query = queryManager.createQuery(xpathQuery, Query.XPATH);
+            NodeIterator nodeIterator = query.execute().getNodes();
+            
+            if (nodeIterator.hasNext())
+            {
+                return (Node) nodeIterator.next();
+            }
+            
+            return null;
+        }
+        catch (RepositoryException e)
+        {
+            throw new FormsException("Error executing the query to find the frozen content nodes for the form '" + formId + "'.", e);
+        }
+        finally
+        {
+            if (session != null)
+            {
+                session.logout();
+            }
+        }
+    }
+    
+    /**
      * Get the forms in a specified content.
-     * @param content the content.
+     * @param content the c_resolverontent.
      * @return the forms as a list.
      * @throws FormsException if an error occurs.
      */
@@ -302,6 +348,50 @@
     }    
     
     /**
+     * Get the content corresponding to the form with the given id
+     * @param formId the id of the form
+     * @return the {@link Content} corresponding to the form with the given id
+     * @throws FormsException if something goes wrong when either querying the form JCR node or finding its parent {@link Content} 
+     */
+    public Content getFormContent(String formId) throws FormsException
+    {
+        Session session = null;
+        try
+        {
+            session = _repository.login();
+            
+            // Build the query
+            String xpathQuery = "//element(*, ametys:content)/" + FORMS_NODE + "/*[@" + FORM_PROPERTY_ID + " = '" + formId + "']";
+            
+            // Execute
+            QueryManager queryManager = session.getWorkspace().getQueryManager();
+            Query query = queryManager.createQuery(xpathQuery, Query.XPATH);
+            NodeIterator nodeIterator = query.execute().getNodes();
+            
+            if (nodeIterator.hasNext())
+            {
+                Node node = nodeIterator.nextNode().getParent().getParent();
+                Content content = (Content) _resolver.resolve(node, false);
+                return content;
+            }
+            
+            return null;
+        }
+        catch (RepositoryException e)
+        {
+            throw new FormsException("Error executing the query to find the content containing the form of id " + formId, e);
+        }
+        finally
+        {
+            if (session != null)
+            {
+                session.logout();
+            }
+        }
+        
+    }
+    
+    /**
      * Extract all the form objects from a node
      * @param node the node
      * @return the forms list of this node
@@ -449,6 +539,7 @@
             String receiptFieldFromAddress = _getSingleProperty(formNode, FORM_PROPERTY_RECEIPT_FROM_ADDRESS, "");
             String redirectTo = _getSingleProperty(formNode, FORM_PROPERTY_REDIRECT_TO, "");
             Collection<String> emails = _getMultipleProperty(formNode, FORM_PROPERTY_EMAILS);
+            String workflowName = _getSingleProperty(formNode, FORM_PROPERTY_WORKFLOW_NAME, "");
             
             form = new Form();
             
@@ -460,6 +551,7 @@
             form.setReceiptFieldFromAddress(receiptFieldFromAddress);
             form.setNotificationEmails(new HashSet<String>(emails));
             form.setRedirectTo(redirectTo);
+            form.setWorkflowName(workflowName);
             
             _extractFields(formNode, form);
         }
@@ -563,6 +655,7 @@
         formNode.setProperty(FORM_PROPERTY_RECEIPT_FROM_ADDRESS, form.getReceiptFieldFromAddress());
         formNode.setProperty(FORM_PROPERTY_EMAILS, emailArray);
         formNode.setProperty(FORM_PROPERTY_REDIRECT_TO, form.getRedirectTo());
+        formNode.setProperty(FORM_PROPERTY_WORKFLOW_NAME, form.getWorkflowName());
     }
     
     /**
@@ -751,9 +844,9 @@
     }
     
     /**
-     * Remove a form
+     * Remove a form 
      * @param form The form to remove
-     * @throws FormsException
+     * @throws FormsException if an error occurs when removing the form
      */
     public void remove(Form form) throws FormsException
     {
Index: main/plugin-forms/src/org/ametys/plugins/forms/processing/GetContentAction.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/processing/GetContentAction.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/processing/GetContentAction.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
Index: main/plugin-forms/src/org/ametys/plugins/forms/processing/ProcessFormAction.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/processing/ProcessFormAction.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/processing/ProcessFormAction.java	(working copy)
@@ -69,6 +69,7 @@
 import org.ametys.plugins.forms.jcr.FormPropertiesManager;
 import org.ametys.plugins.forms.table.DbTypeHelper;
 import org.ametys.plugins.forms.table.FormTableManager;
+import org.ametys.plugins.forms.workflow.FormEntriesWorkflow;
 import org.ametys.plugins.repository.AmetysObjectResolver;
 import org.ametys.plugins.repository.UnknownAmetysObjectException;
 import org.ametys.runtime.captcha.CaptchaHelper;
@@ -81,6 +82,8 @@
 import org.ametys.web.repository.page.Page;
 import org.ametys.web.site.SiteConfigurationExtensionPoint;
 
+import com.opensymphony.workflow.WorkflowException;
+
 /**
  * Action that processes the user submitted data on a form.
  */
@@ -145,6 +148,9 @@
     /** The URI prefix handler */
     protected URIPrefixHandler _prefixHandler;
     
+    /** The workflow component for form entries */
+    protected FormEntriesWorkflow _formEntriesWorkflow;
+    
     @Override
     public void service(ServiceManager serviceManager) throws ServiceException
     {
@@ -154,7 +160,8 @@
         _sourceResolver = (SourceResolver) serviceManager.lookup(SourceResolver.ROLE);
         _ametysObjectResolver = (AmetysObjectResolver) serviceManager.lookup(AmetysObjectResolver.ROLE);
         _siteConfiguration = (SiteConfigurationExtensionPoint) serviceManager.lookup(SiteConfigurationExtensionPoint.ROLE);
-        _prefixHandler = (URIPrefixHandler) manager.lookup(URIPrefixHandler.ROLE);
+        _prefixHandler = (URIPrefixHandler) serviceManager.lookup(URIPrefixHandler.ROLE);
+        _formEntriesWorkflow = (FormEntriesWorkflow) serviceManager.lookup(FormEntriesWorkflow.ROLE);
     }
 
     @Override
@@ -190,7 +197,7 @@
         }
 
         _insertInput(form, input);
-
+        
         _sendEmails(form, input, siteName);
 
         if (StringUtils.isNotEmpty(form.getRedirectTo()))
@@ -396,8 +403,9 @@
      * @param form the Form object.
      * @param input the user input.
      * @throws FormsException if an error occurs.
+     * @throws WorkflowException if an error occurs when initializing the workflow of the form entry
      */
-    protected void _insertInput(Form form, Map<String, FieldValue> input) throws FormsException
+    protected void _insertInput(Form form, Map<String, FieldValue> input) throws FormsException, WorkflowException
     {
         final String tableName = FormTableManager.TABLE_PREFIX + form.getId();
 
@@ -454,7 +462,14 @@
                     values.append(", ");
                 }
             }
-
+            
+            if (_formTableManager.hasWorkflowIdColumn(form.getId()))
+            {
+                // Ensure compatibility with form entries that remained without workflow
+                sql.append(", ").append(FormTableManager.WORKFLOW_ID_FIELD);
+                values.append(", ?");
+            }
+              
             sql.append(") VALUES (").append(values).append(")");
 
             if (getLogger().isDebugEnabled())
@@ -488,10 +503,11 @@
      * @param stmt the prepared statement.
      * @param dbType the database type.
      * @throws SQLException if a SQL error occurs.
+     * @throws WorkflowException if an exception occurs when initializing the workflow of the form entry
      */
-    protected void _setParameters(Form form, Map<String, FieldValue> input, PreparedStatement stmt, DatabaseType dbType) throws SQLException
+    protected void _setParameters(Form form, Map<String, FieldValue> input, PreparedStatement stmt, DatabaseType dbType) throws SQLException, WorkflowException
     {
-        // First two are id (auto-increment) and test;
+        // First two are id (auto-increment) and creation date
         int index = 1;
         if (DbTypeHelper.insertIdentity(dbType) && !DatabaseType.DATABASE_ORACLE.equals(dbType))
         {
@@ -549,6 +565,16 @@
             }
             index++;
         }
+        
+        // Ensure compatibility with form entries that remained without workflow
+        if (_formTableManager.hasWorkflowIdColumn(form.getId()))
+        {
+            String workflowName = form.getWorkflowName();
+            int initialActionId = _formEntriesWorkflow.getInitialAction(workflowName);
+            
+            long workflowInstanceId = _formEntriesWorkflow.initialize(form.getWorkflowName(), initialActionId, Collections.EMPTY_MAP);
+            stmt.setLong(index, workflowInstanceId);
+        }
     }
 
     /**
Index: main/plugin-forms/src/org/ametys/plugins/forms/table/DbTypeHelper.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/table/DbTypeHelper.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/table/DbTypeHelper.java	(working copy)
@@ -216,6 +216,31 @@
     }
     
     /**
+     * Get the integer type identifier corresponding to the database type.
+     * @param dbType the database type.
+     * @return the integer type identifier (to be included in CREATE statement).
+     */
+    public static String getIntegerType(DatabaseType dbType)
+    {
+        switch (dbType)
+        {
+            case DATABASE_MYSQL:
+                break;
+            case DATABASE_DERBY:
+                break;
+            case DATABASE_ORACLE:
+                break;
+            case DATABASE_POSTGRES:
+                break;
+            case DATABASE_UNKNOWN:
+                break;
+            default:
+                break;
+        }
+        return "INTEGER";
+    }
+    
+    /**
      * Get the date and time type identifier corresponding to the database type.
      * @param dbType the database type.
      * @return the real date and time type identifier (to be included in CREATE statement).
@@ -447,5 +472,4 @@
         
         return buff.toString();
     }
-    
 }
